using Supabase;
using Supabase.Postgrest.Attributes;
using Supabase.Postgrest.Models;
using Supabase.Postgrest.Responses;
using Supabase.Realtime;
using System.ComponentModel;
using System.Reflection;





namespace TestProject1
{
    [TestClass]
    public class UnitTest1
    {
        static string url = "https://vkxcxcimqqswxqxncmof.supabase.co";
        static string key = "eyJhbGciOiJIUzI1NiIsInR5cCI6IkpXVCJ9.eyJpc3MiOiJzdXBhYmFzZSIsInJlZiI6InZreGN4Y2ltcXFzd3hxeG5jbW9mIiwicm9sZSI6ImFub24iLCJpYXQiOjE3MjkxNjE0NDcsImV4cCI6MjA0NDczNzQ0N30.UZK8UzVHu47SZV4RtWRHVcOfTL3333_Kb_BbHDeqOCo";
        static Supabase.SupabaseOptions options = new Supabase.SupabaseOptions
        {
            AutoConnectRealtime = true
        };

        Supabase.Client supabase = new Supabase.Client(url, key, options);
        public async void Initialize()
        {
            await supabase.InitializeAsync();
        }
        public async Task<ModeledResponse<Season>> Get()
        {
            return await supabase.From<Season>().Get();
        }
        public async Task<ModeledResponse<Style>> Get1()
        {
            return await supabase.From<Style>().Get();
        }
        public async Task<ModeledResponse<Type>> Get2()
        {
            return await supabase.From<Type>().Get();
        }
        public async Task<ModeledResponse<Users>> Get3()
        {
            return await supabase.From<Users>().Get();
        }
        public async Task<ModeledResponse<type_subtype>> Get4()
        {
            return await supabase.From<type_subtype>().Get();
        }
        [TestMethod]
        public void TestSeasonReturn()//   ,       
        {
           
            Initialize();
            Task<ModeledResponse<Season>> result = Get();
            result.Wait();
            var seson = result.Result.Models;
            Assert.IsNotNull(seson);
        }
        [TestMethod]
        public void TestTypeReturn()//   ,       
        {

            Initialize();
            Task<ModeledResponse<Type>> result = Get2();
            result.Wait();
            var type = result.Result.Models;
            Assert.IsNotNull(type);
        }
        [TestMethod]
  

        public void TestStyleReturn()//   ,       
        {

            Initialize();
            Task<ModeledResponse<Style>> result = Get1();
            result.Wait();
            var styles = result.Result.Models;
            Assert.IsNotNull(styles);
        }
        [TestMethod]


        public void TestUsersReturn()//   ,       
        {

            Initialize();
            Task<ModeledResponse<Users>> result = Get3();
            result.Wait();
            var users = result.Result.Models;
            Assert.IsNotNull(users);
        }

        [TestMethod]


        public void TestSubtypereturn()//   ,       
        {

            Initialize();
            Task<ModeledResponse<type_subtype>> result = Get4();
            result.Wait();
            var subs = result.Result.Models;
            Assert.IsNotNull(subs);
        }


        [TestMethod]
        public void TestStyle()//   ,       
        {
            Initialize();
            Task<ModeledResponse<Style>> result = Get1();
            result.Wait();
            var styles = result.Result.Models;

            // ,       id = 5
            var style = styles.FirstOrDefault(s => s.Id == 5);
            Assert.IsNotNull(styles);

            // ,   title  ""
            Assert.AreEqual("", style.title);
        }


        [TestMethod]
        public void TestType()//   ,      7 
        {
            Initialize();
            Task<ModeledResponse<Type>> result = Get2();
            result.Wait();
            var types = result.Result.Models;
            
            Assert.AreEqual(7, types.Count, "       7.");

        }


        [TestMethod]
        public void TestSubtype()//   ,    26 
        {
            Initialize();
            Task<ModeledResponse<type_subtype>> result = Get4();
            result.Wait();
            var subs = result.Result.Models;

            Assert.AreEqual(26, subs.Count, "       7.");

        }
        [TestMethod]
        public void TestTypeNegative()// ,  
        {
            Initialize();
            Task<ModeledResponse<Type>> result = Get2();
            result.Wait();
            var types = result.Result.Models;
            Assert.AreNotEqual(8, types.Count, "       7.");

        }

        [TestMethod]
        public void TestUser() //   ,    ID 2   ""
        {
            Initialize();
            Task<ModeledResponse<Users>> result = Get3();
            result.Wait();
            var users = result.Result.Models;

            // ,       id = 2
            var user = users.FirstOrDefault(u => u.Id == 2);
      

            // ,   name  ""
            Assert.AreEqual("Admin", user.name, "   ID 2   ''.");
        }
    }

}
